#include <io.h>
#include <system.h>
#include <stdio.h>

#include <system.h>
#include "system.h"

/* ---------------Automatically generated headers start--------------------------------*/
#include "BitstreamVeraMono.h"
// #include "fg_asianlick.h"
#include "fg_bath.h"
#include "fg_bicycle.h"
#include "fg_boxhead.h"
#include "fg_cartree.h"
#include "fg_cat.h"
#include "fg_cmongler.h"
#include "fg_cone.h"
#include "fg_dice.h"
#include "fg_farm.h"
#include "fg_frogdog.h"
// #include "fg_japcar.h"
#include "fg_lily.h"
#include "fg_lionking.h"
#include "fg_rainbowlips.h"
#include "fg_snail.h"
#include "fg_osprey.h"
#include "fg_raptor.h"
#include "fg_sagan.h"
#include "fg_joseph.h"
/* --------------------Automatically generated headers end ----------------------------*/

/*--------------------------------------Definitions------------------------------------*/
#define OP_WRITE                   (0x0 << 1)
#define OP_SET_VERT_OFFSET         (0x1 << 1)
#define OP_SEEK_ROW                (0x4 << 1)
#define OP_TILE_SET_CURRENT        (0x5 << 1)
#define OP_TILE_WRITE              (0x6 << 1)
#define OP_TILE_SEEK               (0x7 << 1)
#define OP_TILE_TO_CHANGE          (0x8 << 1)
#define OP_TILE_CHANGE_TO          (0xA << 1)
#define OP_TILE_SET_ANIM_STATE     (0xB << 1)
#define OP_TINT                    (0xC << 1)
#define OP_TILE_TRANSFORMER_CHANGE (0xD << 1)

#define SEE_THRU 2047
#define NUM_PICS 18
/*--------------------------------------End_Definitions--------------------------------*/

/*-------------------------------------Arrays_and_Variable_Definitions-----------------*/
const int daytext[7][9] = 
{
    {TILE_blank, TILE_blank, TILE_M, TILE_o, TILE_n, TILE_d, TILE_a, TILE_y, TILE_blank},
    {TILE_blank, TILE_T, TILE_u, TILE_e, TILE_s, TILE_d, TILE_a, TILE_y, TILE_blank},
    {TILE_W, TILE_e, TILE_d, TILE_n, TILE_e, TILE_s, TILE_d, TILE_a, TILE_y},
    {TILE_blank, TILE_T, TILE_h, TILE_u, TILE_r, TILE_s, TILE_d, TILE_a, TILE_y},
    {TILE_blank, TILE_blank, TILE_F, TILE_r, TILE_i, TILE_d, TILE_a, TILE_y, TILE_blank},
    {TILE_blank, TILE_S, TILE_a, TILE_t, TILE_u, TILE_r, TILE_d, TILE_a, TILE_y},
    {TILE_blank, TILE_blank, TILE_S, TILE_u, TILE_n, TILE_d, TILE_a, TILE_y, TILE_blank},
};

int seconds = 54;
int minutes = 59;
int hours = 11;
int letterDay = 0; // 0 is monday, 1 tuesday, etc., used for displaying days in words
int day = 27;
int year = 9; // 20XX
int month = 12;

//position 0 is minutes,1 is hours,2 is am or pm, 3 is day, 4 is month, 5 is year
int incrementposition = 0;

// stores the last second in which a button was pressed, used to reset tint
int tintTimerSeconds = 0;

int PM = 1; //if 0, its PM. 1 = PM
int tint = 0; // if tint is 1 then whatever incrementposition is should be tinted

int x = 0;
int y = 0;
int timesThrough = 0;
unsigned short posPrev;
int currentPicRow = 0;
int currentPic = 0;

unsigned int lfsr = 0xACE1u;
unsigned randpic;

unsigned short day_change;
unsigned short long_month;
unsigned short short_month;
unsigned short end_month;

/* ----------------------------List of available images -------------------------------*/
unsigned short *images[NUM_PICS] =
{
    fg_cmongler,
    // fg_asianlick,
    fg_frogdog,
    fg_farm,
    // fg_japcar,
    fg_lily,
    fg_boxhead,
    fg_bath,
    fg_bicycle,
    fg_cartree,
    fg_cat,
    fg_cone,
    fg_dice,
    fg_lionking,
    fg_snail,
    fg_rainbowlips,
    fg_osprey,
    fg_raptor,
    fg_sagan,
    fg_joseph
};

/* ***********************List of the heights of the images above **********************/
int heights[NUM_PICS] =
{
    176, /* cmongler */
    /* 194, asianlick */
    138, /* frogdog */
    90, /* farm */
    // 226, /* japcar */
    108, /* lily */
    87, /* boxhead */
    108, /* bath */
    151, /* bicycle */
    191, /* cartree */
    104, /* cat */ 
    142, /* cone */
    108, /* dice */
    102, /* lionking */
    86, /* snail */
    108, /* rainbowlips */
    95, /* osprey */
    164, /* raptor */
    119, /* sagan */
    189 /* jospeh */
};
/**************************End List of Hights for images********************************/

/*-------------------------Random Number Function--------------------------------------*/
void random_number()
{
    unsigned int bit;
    
    do{
    bit = ((lfsr >> 0) ^ (lfsr >> 2) ^ (lfsr >> 3) ^ (lfsr >>5)) & 1;
    lfsr = (lfsr >> 1) | (bit << 15);
    } while (randpic == lfsr % NUM_PICS);
    
    randpic = lfsr % NUM_PICS;
}
/*-------------------------End Random Number Function----------------------------------*/

/**************************Setup_Tiles_Function*****************************************/
void setup_tiles()
{
    int i = 0;
    int j = 0;
    for (i = 0; i < 72; i++)
    {
        IOWR_16DIRECT(VGA_BASE, OP_TILE_SET_CURRENT, i);
        IOWR_16DIRECT(VGA_BASE, OP_TILE_SEEK, 0);
        for (j = 0; j < 256; j++) IOWR_16DIRECT(VGA_BASE,OP_TILE_WRITE, tile_data[i][j]);
    }

    /* Now blank out centers for clock effect */
    for (i = 0; i < 32; i++)
    {
        IOWR_16DIRECT(VGA_BASE, OP_TILE_SET_CURRENT, i);
        IOWR_16DIRECT(VGA_BASE, OP_TILE_SEEK, 15 * 8);
        for (j = 0; j < 16; j++) IOWR_16DIRECT(VGA_BASE, OP_TILE_WRITE, 0);
    }

    /* Blank out centers of big number tiles */
    for (i = 32; i < 72; i++)
    {
        IOWR_16DIRECT(VGA_BASE, OP_TILE_SET_CURRENT, i);
        if (((i-1) % 4 == 1) || ((i-1) % 4 == 2)) /* CLean up this shit */
            IOWR_16DIRECT(VGA_BASE, OP_TILE_SEEK, 0);
        else IOWR_16DIRECT(VGA_BASE, OP_TILE_SEEK, 31 * 8);

        for (j = 0; j < 8; j++) IOWR_16DIRECT(VGA_BASE, OP_TILE_WRITE, 0);
    }
}
/****************************End_Setup_Tiles_Function***********************************/


/*-----------------------------Change_Tile_Function------------------------------------*/
void change_tile(const int currentTile, const int newTile, const int transformTile,
    const int animationState, const int tint)
{
        /* This is the only function which changes the tile which the current tile will
         * animate to ANIMATION state is either 0 for clear, 1 for no animation, and 2
         * for animation, but the msb of the animation tells whether it is part of a
         * big number or small. */
        IOWR_16DIRECT(VGA_BASE, OP_TILE_TO_CHANGE, currentTile);
        IOWR_16DIRECT(VGA_BASE, OP_TILE_CHANGE_TO, newTile);
        IOWR_16DIRECT(VGA_BASE, OP_TILE_SET_ANIM_STATE, animationState);
        IOWR_16DIRECT(VGA_BASE, OP_TILE_TRANSFORMER_CHANGE, transformTile);
        IOWR_16DIRECT(VGA_BASE, OP_TINT, tint);
}
/*-----------------------------End_Change_Tile_Function--------------------------------*/

/******************************Place_Letter_Days_Function*******************************/
void place_letter_days(const int animation, const int tint)
{   
    /* places the day of week as a word */
    int x;
    const int base = 41;
    for (x = 0; x < 9; x++)
        change_tile(base + x, daytext[letterDay][x],
            daytext[(letterDay + 1) % 7][x], animation, tint);
}
/****************************End_Place_Letters_Days_Function****************************/

/*---------------------------Place_AM_PM_Function--------------------------------------*/
void place_am_pm(const int animation, const int tint)
{
        change_tile(28, TILE_A+3*PM, TILE_A+3*(PM^1), animation, tint);
        change_tile(29, TILE_M, TILE_M, animation, tint);
}
/*--------------------------End_Place_AM_PM_Function-----------------------------------*/

/***************************Place_Seconds_Function**************************************/
void place_seconds() // Places seconds, animates only when values change
{
    //if seconds 59, change 10s place to 0 not 6
    if (seconds == 59) change_tile(25,TILE_0 + seconds/10,TILE_0,2,0);
    
    //if seconds singles place is 9, change 10s to plus 1
    else if (seconds%10==9) change_tile(25,TILE_0 + seconds/10,TILE_0+seconds/10+1,2,0);
    else change_tile(25,TILE_0 + seconds/10,TILE_0+seconds/10+1,1,0);

    if (seconds % 10 == 9) change_tile(26,TILE_0 + seconds % 10,TILE_0,2,0);
    else change_tile(26,TILE_0 + seconds % 10,TILE_0+seconds%10 + 1,2,0);
}
/***********************End_Place_Seconds_Function**************************************/

/*----------------------Place_Ones_Minutes---------------------------------------------*/
void place_ones_minutes(const int animation, const int tint)
{
    int correction;
    int tileOnes = TILE_0_NW + 4 * (minutes % 10);
    if (minutes % 10 == 9) correction = -40;
    else correction = 0;

    change_tile(8, tileOnes, tileOnes + 4 + correction, animation, tint);
    change_tile(9, tileOnes + 1, tileOnes + 5 + correction, animation, tint);
    change_tile(18, tileOnes + 2, tileOnes + 6 +correction, animation, tint);
    change_tile(19, tileOnes + 3, tileOnes + 7 + correction, animation, tint);
}
/*----------------------End_Place_Ones_Minutes-----------------------------------------*/

/*************************Place_Tens_Minutes********************************************/
void place_tens_minutes(const int animation, const int tint)
{
    int correction;
    int tileTens = TILE_0_NW + 4 * (minutes / 10);
    if (minutes/10 == 5) correction = -24;
    else correction = 0;

    change_tile(6, tileTens, tileTens + 4 + correction, animation, tint);
    change_tile(7, tileTens + 1, tileTens + 5 + correction, animation, tint);
    change_tile(16, tileTens + 2, tileTens + 6 +correction, animation, tint);
    change_tile(17, tileTens + 3, tileTens + 7 + correction, animation, tint);
}
/*************************End_Place_Tens_Minutes****************************************/

/*------------------------Place_Ones_Hours_Function------------------------------------*/
void place_ones_hours(const int animation, const int tint)
{
    int correction;
    int tileOnes = TILE_0_NW + 4 * (hours % 10);
    if (hours == 12) correction = -8;
    else if (hours == 9) correction = -40;
    else correction = 0;

    change_tile(3, tileOnes, tileOnes + 4 + correction, animation, tint);
    change_tile(4, tileOnes + 1, tileOnes + 5 + correction, animation, tint);
    change_tile(13, tileOnes + 2, tileOnes + 6 + correction, animation, tint);
    change_tile(14, tileOnes + 3, tileOnes + 7 + correction, animation, tint);
}
/*------------------------End_Place_Ones_Hours_Function--------------------------------*/

/**************************Place_Tens_Hours_Function************************************/
void place_tens_hours(const int animation, const int tint)
{
    int correction;
    int tileTens = TILE_0_NW + 4 * (hours/10);
    if (hours == 12) correction = -8;
    else correction = 0;

    change_tile(1, tileTens, tileTens + 4 + correction, animation, tint);
    change_tile(2, tileTens + 1, tileTens + 5 + correction, animation, tint);
    change_tile(11, tileTens + 2, tileTens + 6 + correction, animation, tint);
    change_tile(12, tileTens + 3, tileTens + 7 + correction, animation, tint);
}
/*************************End_Place_Tens_Hours_Function*********************************/

/*------------------------Place_Ones_Days_Function-------------------------------------*/
void place_ones_days(const int animation, const int tint)
{
    int correction = 0;
    int tileOnes = TILE_0 + (day % 10);
    if (day % 10 == 9) correction = -10;
    if (day == 31 && long_month) correction = -1;
    else if (day == 30 && short_month) correction = 0;
    else if (day == 28 && (month == 2)) correction = -8;
    
    change_tile(36, tileOnes, tileOnes + 1 + correction, animation, tint);
}
/*------------------------End_Place_Ones_Days_Function---------------------------------*/

/*************************Place_Tens_Days_Function**************************************/
void place_tens_days(int animation, int tint)
{
    int tileTens = TILE_0 + day/10;
    if ((day == 31 && long_month)||(day == 30 && short_month)||(day == 28 && month == 2))
    {
        change_tile(35,tileTens,TILE_0,animation,tint);
    }
    else change_tile(35,tileTens,tileTens+1,animation,tint);
}
/*************************End_Place_Tens_Days_Function**********************************/

/*-------------------------Place_Ones_Month_Function-----------------------------------*/
void place_ones_month(int animation, int tint)
{
    int correction;
    int tileOnes = TILE_0 + (month % 10);
    if (month == 9) correction = -10;
    else if (month == 12) correction = -2;
    else correction = 0;

    change_tile(33, tileOnes, tileOnes + 1 + correction, animation, tint);
}
/*-------------------------End_Place_Ones_Month_Function-------------------------------*/

/**************************Place_Tens_Month_Function************************************/
void place_tens_month(int animation, int tint)
{
    int correction;
    int tileTens = TILE_0 + month/10;
    if (month == 12) correction = -2;
    else correction = 0;

    change_tile(32,tileTens,tileTens+1+correction,animation,tint);
}
/*************************End_Place_Tens_Month_Function*********************************/

/*------------------------Place_Ones_Year_Function-------------------------------------*/
void place_ones_year(int animation, int tint)
{
    int correction;
    if (year % 10 == 9) correction = -10;
    else correction = 0;
    int tileOnes = TILE_0 + (year % 10);
    
    change_tile(39, tileOnes, tileOnes + 1 + correction, animation, tint);
}
/*-------------------------End_Place_Ones_Year_Function--------------------------------*/

/**************************Place_Tens_Year_Function*************************************/
void place_tens_year(int animation, int tint)
{
    int correction = 0;
    int tileTens = TILE_0 + (year/10);

    change_tile(38, tileTens, tileTens + 1 + correction, animation, tint);
}
/**************************End_Place_Tens_Year_Function*********************************/

/*-------------------------Draw_Pictures_Function--------------------------------------*/
inline void draw_pix()
{
    if (x < 8 || x >= 152) IOWR_16DIRECT(VGA_BASE, OP_WRITE, SEE_THRU);
    else IOWR_16DIRECT(VGA_BASE, OP_WRITE, images[currentPic][currentPicRow*144 + x - 8]);
}
/*-------------------------------------------------------------------------------------*/


/******************************Manual_Time_Change_Function******************************/
/***************************************************************************************/
static void time_change(int key)
/* gets the value of keys passed to it, decides how to increment or decrement
 * IF KEY 14 then decrease value
 * IF KEY 13 then increase value
 * IF KEY 11 then decrease increment position which points to value
 * IF KEY 7 then increase increment position which points to value */
{
    if (key == 14) /* Decrease values of selected tiles */
    {
        switch(incrementposition)
        {
            case 0:
            {
                if (minutes == 0) minutes = 59;
                else minutes--;
                break;
            }
            case 1:
            {
                if (hours == 1) hours = 12;
                else hours--;
                break;
            }
            case 2:
            {
                if (long_month && day == 1) day = 31;
                else if (short_month && day == 1) day = 30;
                else if (month == 2 && day == 1) day = 28;
                else day--;
                break;
            }
            case 3:
            {
                if (month == 1) month = 12;
                else month--;
                break;
            }
            case 4:
            {
                if (year == 0) year = 99;
                year--;
                break;   
            }
            case 5:
            {
               PM = PM^1; 
               break;  
            }
            case 6:
            {
              if (letterDay == 0) letterDay = 6;
              else letterDay--;
              break;
            }
        }    
        
    }
    else if (key == 13) /* Increase value of selected tiles */
    {
        switch(incrementposition)
        {
            case 1:
            {
                place_ones_hours(10,1);
                if (hours%10 == 9) 
                {
                    place_tens_hours(10,1);
                    hours++;
                }
                if (hours == 12) 
                {
                    place_tens_hours(10,1);
                    hours = 1;
                }
                else hours++;
                break;   
            }
            case 0:
            {
                place_ones_minutes(10,1);
                if (minutes%10 == 9) place_tens_minutes(10,1);
                if (minutes == 59) minutes = 0;
                else minutes++;
                break;
                
            }
            case 2:
            {
                place_ones_days(2,1);
                if ((day%10)==9) place_tens_days(2,1);
                if ((long_month && day == 31) || (short_month && day == 30) ||
                (month == 2 && day == 28)) 
                {
                    place_tens_days(2,1);
                    day = 1;
                }
                else day++;
                break;
            }   
            case 3:
            {
                place_ones_month(2,1);
                if ((long_month && day == 31) || (short_month && day == 30) ||
                (month == 2 && day == 28)) 
                {
                    place_tens_month(2,1);
                    
                    if(month == 12) month = 1;
                }
                else month++;
                break;
            }
            case 4:
            {
                place_ones_year(2,1);
                if (year%10 == 9) place_tens_year(2,1);
                year++;
                break;
            }
            case 5:
            {
                place_am_pm(2,1);
                PM = PM^1;
                break;
            }
            case 6:
            {
                place_letter_days(2,1);
                if (letterDay == 6) letterDay = 0;
                else letterDay++;
                break;
            }
            default:
                break;
        }
    }
    else if (key==11) 
    {
        if (incrementposition == 0) incrementposition = 6;
        else incrementposition--;

    }
    else if (key==7)
    {
        if (incrementposition == 6) incrementposition = 0;
        else incrementposition++;
    }
}
/**************************End_Manual_Time_Change_Function******************************/
/***************************************************************************************/

/*---------------------------Get_Next_Picture_Row--------------------------------------*/
static void nextRow()
{
    int q = 0;
    currentPicRow++;
    if (currentPicRow == heights[currentPic])
    {
        for (; q < 8; q++)
        {
            IOWR_16DIRECT(VGA_BASE, OP_SEEK_ROW, y);
            for (x = 0; x < 162; x++)
                IOWR_16DIRECT(VGA_BASE, OP_WRITE, SEE_THRU);
            y++;
        }
        random_number();
        currentPic = randpic;
        currentPicRow = 0;
    }
    IOWR_16DIRECT(VGA_BASE, OP_SEEK_ROW, y);
}
/*------------------------End_Get_Next_Picture_Row-------------------------------------*/

/***************************Interrupt_Function******************************************/
/***************************************************************************************/
static void timer_interrupt_handler()
{
    // MAIN WORK function, gets called whenever hardware throws an interrupt which happens
    // if a key is pressed and if a second has passed.
    
    int key = IORD_16DIRECT(TIMERMODULE_BASE,0);
    int tintMinutes = 0, tintHours = 0, tintDays = 0, tintMonths = 0;
    int tintYears = 0, tintAM = 0, tintLetter = 0;
    
    if (tint == 1)/*Check for tint*/
    {
        switch (incrementposition)/*Tint correct tiles*/
        {
            case 0:
            {
                tintMinutes = 1;
                break;   
            }    
            case 1:
            {
                tintHours = 1;
                break;   
            }
            case 2:
            {
                tintDays = 1;
                break;   
            }
            case 3:
            {
                tintMonths = 1;
                break;   
            }
            case 4:
            {
                tintYears = 1;
                break;   
            }
            case 5:
            {
                tintAM = 1;
                break;   
            }
            case 6:
            {
                tintLetter = 1;
                break;   
            }
            default:
            {
                break;   
            }
                    
        }
    }
    
    /*Do a check to see if the day is ending */
    if (seconds == 59 && minutes == 59 && hours == 11 && PM == 1)
    {
        day_change = 1;
    }
    else day_change = 0;
    
    /* Do a check to see if the month has 31 days */
    if (month == 1 || month == 3 || month == 5 || month == 7 || month == 8 ||
        month == 10 || month == 12)
    {
        long_month = 1;
    }
    else long_month = 0;
    
    /* Do a check to see if the month is short */
    if (month == 4 || month == 6 || month == 9 || month == 11) short_month = 1;
    else short_month = 0;
    
    /* Check to see if the month is ending */
    if (day_change && ((long_month && day == 31) || (short_month && day == 30) || (month == 2 && day == 28)))
    {
        end_month = 1;    
    }
    else end_month = 0;
    
    /*******If key is equal to zero than a second has gone by, so change the time!******/
    if (key == 0)
    {
        place_seconds();
        
        /*sets tint to 0 if 50 seconds have gone by*/
        if (tintTimerSeconds == seconds + 10) tint = 0;
        
        /*-------------------Check to see if tile should be animated-------------------*/
        if (seconds == 59 && minutes == 59 && hours == 11) place_am_pm(2,tintAM);
        else place_am_pm(1,tintAM); /* 1 means "do not animate", 2 means "animate" */

        if (seconds == 59) place_ones_minutes(10,tintMinutes);
        else place_ones_minutes(1,tintMinutes);

        if (seconds == 59 && (minutes%10) == 9) place_tens_minutes(10,tintMinutes);
        else place_tens_minutes(1,tintMinutes);

        if (seconds == 59 && minutes == 59) place_ones_hours(10,tintHours);
        else place_ones_hours(1,tintHours);

        if (seconds == 59 && minutes == 59 && (hours%10) == 9) 
        {
            place_tens_hours(10,tintHours);
        }
        else place_tens_hours(1,tintHours);


        if (day_change)
        {
            place_ones_days(2,tintDays);
            place_letter_days(2,tintLetter);
        }
        else
        {
             place_ones_days(1,tintDays);
             place_letter_days(1,tintLetter);
        }

        if (day_change && (day % 10 == 9 || end_month)) place_tens_days(2,tintDays);
        else place_tens_days(1,tintDays);

        if (end_month) place_ones_month(2,tintMonths);
        else place_ones_month(1,tintMonths);

        if (end_month && ((month%10==9) || month == 12)) place_tens_month(2,tintMonths);
        else place_tens_month(1,tintMonths);

        if (end_month && month == 12) place_ones_year(2,tintYears);
        else place_ones_year(1,tintYears);

        if (end_month && month == 12 && (year%10 == 9)) place_tens_year(2,tintYears);
        else place_tens_year(1,tintYears); 
        /*------------------End Check for Tile Animation-------------------------------*/


        unsigned short pos = IORD_16DIRECT(VGA_BASE, 0);
        if (pos<posPrev) timesThrough++;
        posPrev=pos;

        for (; y < (pos + timesThrough*1024); y++)
        {
            nextRow();
            for (x = 0; x < 161; x++) draw_pix();
        }


        /*-----------------Time Increment and Adjustment-------------------------------*/
        if (seconds == 59)
        {
            seconds = 0;
            if (minutes == 59)
            {
                minutes = 0;
                if (hours == 11) 
                {
                    if (PM == 1) 
                    { 
                        PM = PM^1;
                        
                        if (letterDay == 6) letterDay = 0;
                        else letterDay++;

                        if (end_month)
                        {
                            day = 1;
                            if (month == 12)
                            {
                                month = 1;
                                year++;
                            }
                            else month++;
                        }
                        else day++;
                    }
                    hours++;
                }
                else if(hours == 12) hours = 1;
                else hours++;
            }
            else minutes++;
        }
        else seconds++;
        /*--------------------End Time Increment and Adjustment------------------------*/
    }
    /**************************Else a Key was Pressed***********************************/
    else
    {
        tintTimerSeconds=seconds;
        tint=1;
        time_change(key);
    }

    IOWR_16DIRECT(TIMERMODULE_BASE, 0, 0); /* Reenable interrupts */
}
/***********************End_Interrupt_Function******************************************/
/***************************************************************************************/


/*--------------------------Main Function----------------------------------------------*/
int main() /* Only runs at start-up */
{
    alt_irq_register(TIMERMODULE_IRQ, NULL, (void*)timer_interrupt_handler);

    printf("Hello from Nios II!\n");
    IOWR_16DIRECT(VGA_BASE, OP_SEEK_ROW, 0);
    IOWR_16DIRECT(VGA_BASE, OP_SET_VERT_OFFSET, 0);
    setup_tiles();

    for (y = 0; y < 240 + 64; y++)
    {
        nextRow();
        for (x = 0; x < 161; x++) draw_pix();
    }

    change_tile(37, TILE_slash, TILE_slash, 1, 0);
    change_tile(34, TILE_slash, TILE_slash, 1, 0);
    change_tile(15, TILE_colon, TILE_colon, 1, 0);
    change_tile(24, TILE_colon, TILE_colon, 1, 0);

    printf("Reached end of main.\n");
    return 0;
}
